; Stomp Stomp Devastation
; Version 0.02b (Model Demo #2)
; Released 5/2/2003
; Lead Programmer:  The Dinosorceror of Lava Dome Five
; See http://www.lavadomefive.com/ssd for full credits
;
; Display load screen, set title bar
AppTitle "Stomp Stomp Devastation! v0.02b Model Demo"
Print
Print "Controls:"
Print "---------"
Print
Print "Right mouse button - walk/fly forward"
Print "SPACE bar - walk/fly backward"
Print "Left mouse button - toggle walk/fly mode"
Print "S key or middle mouse button - toggle speed"
Print "D key - display coordinates in bottom left"
Print "R key - reset to starting point (maybe?)"
Print "P key - pause and allow window movement"
Print "E key - select / deselect model in view"
Print "        Num +/- to grow/shrink selected model"
Print
Print "ESC key - exit"
Print
Print "WARNING:  Don't get caught inside foot-traps!"
Print "          Even the R key can't save you then..."
Print
Print "Model load will take a few moments."
Print "Press SPACE to load models"
Print "and begin simulation in 800x600 window..."

; Wait For SPACE
While KeyDown(57) = 0
Wend

; Set graphics display mode
HidePointer
Graphics3D 800,600,32,2
SetBuffer BackBuffer()

; Global variables
Global FlyMode=0
Global FlyTemp=0
Global WalkSpeed#=0.3
Global WalkTemp#=0.3
Global Gravity# = 0.005
Global PlayerGravity# = 0.0
Global ChosenChar = 0
Global ModifyScale# = 1.0

; Set camera and view options
Global CamPivot = CreatePivot( )
Global Camera = CreateCamera( )
MoveEntity CamPivot, 1230, 16.3, 1240
EntityType CamPivot, 1 
EntityRadius CamPivot, 1.5
EntityType Camera, 1
EntityRadius Camera, 1.5
CameraZoom Camera, 1
CameraFogMode Camera, 1
CameraFogRange Camera, 200, 2000
CameraFogColor Camera, 222, 252, 255
CameraRange Camera, 1, 10000
AmbientLight 255, 255, 255

; Create sky
mesh_skybox = MakeSkyBox("world\sky")

; Create landscape from heightmap and plane to avoid "black hole"
Global Terrain = LoadTerrain("world\terrain.bmp")
ScaleEntity Terrain, 5, 150, 5
Global Stone = LoadTexture( "world\ground.jpg" )
EntityTexture Terrain, Stone, 0 , 0
TerrainDetail Terrain, 4000, True
UnderTerrain = CreatePlane()
Global Rock = LoadTexture( "world\underground.jpg" )
EntityTexture UnderTerrain, Rock, 0, 0
ScaleTexture Rock, 4, 4
MoveEntity UnderTerrain, 0, 1, 0
EntityType Terrain, 2
EntityType UnderTerrain, 2

; Begin main character model load sequence from characters.txt
; Ignore array value of 0 for human compatibility (counting starts at 1)
charfile = ReadFile("characters.ini")
While Not ReadLine(charfile) = "STARTDATA" Wend
NumOfCharacters = Int(ReadLine(charfile))
Dim CharName$(NumOfCharacters+1)
Dim CharMeshFilename$(NumOfCharacters+1)
Dim CharPEx#(NumOfCharacters+1)
Dim CharPEy#(NumOfCharacters+1)
Dim CharPEz#(NumOfCharacters+1)
Dim CharSEx#(NumOfCharacters+1)
Dim CharSEy#(NumOfCharacters+1)
Dim CharSEz#(NumOfCharacters+1)
Dim CharREx#(NumOfCharacters+1)
Dim CharREy#(NumOfCharacters+1)
Dim CharREz#(NumOfCharacters+1)
Dim CharEType(NumOfCharacters+1)
Dim CharMesh(NumOfCharacters+1)

; Load character data into array and generate characters in world
For LoadLoop = 1 To NumOfCharacters

	CharName$(LoadLoop) = ReadLine(charfile)
	CharMeshFilename$(LoadLoop) = ReadLine(charfile)
	CharPEx#(LoadLoop) = Float(ReadLine(charfile))
	CharPEy#(LoadLoop) = Float(ReadLine(charfile))
	CharPEz#(LoadLoop) = Float(ReadLine(charfile))
	CharSEx#(LoadLoop) = Float(ReadLine(charfile))
	CharSEy#(LoadLoop) = Float(ReadLine(charfile))
	CharSEz#(LoadLoop) = Float(ReadLine(charfile))
	CharREx#(LoadLoop) = Float(ReadLine(charfile))
	CharREy#(LoadLoop) = Float(ReadLine(charfile))
	CharREz#(LoadLoop) = Float(ReadLine(charfile))
	CharEType(LoadLoop) = Int(ReadLine(charfile))

	CharMesh(LoadLoop) = LoadMesh(CharMeshFilename$(LoadLoop))
	
	PositionEntity CharMesh(LoadLoop), CharPEx#(LoadLoop), CharPEy#(LoadLoop), CharPEz#(LoadLoop)
	ScaleEntity CharMesh(LoadLoop), CharSEx#(LoadLoop), CharSEy#(LoadLoop), CharSEz#(LoadLoop)
	RotateEntity CharMesh(LoadLoop), CharREx#(LoadLoop), CharREy#(LoadLoop), CharREz#(LoadLoop)
	EntityType CharMesh(LoadLoop), CharEType(LoadLoop)
	EntityPickMode CharMesh(LoadLoop), 2

Next
CloseFile(charfile)
; End main character model load sequence

; Begin landscape model load sequence
; Ignore array value of 0 for human compatibility (counting starts at 1)
landfile = ReadFile("landscape.ini")
While Not ReadLine(landfile) = "STARTDATA" Wend
NumOfLands = Int(ReadLine(landfile))
Dim LandName$(NumOfLands+1)
Dim LandMeshFilename$(NumOfLands+1)
Dim LandPEx#(NumOfLands+1)
Dim LandPEy#(NumOfLands+1)
Dim LandPEz#(NumOfLands+1)
Dim LandSEx#(NumOfLands+1)
Dim LandSEy#(NumOfLands+1)
Dim LandSEz#(NumOfLands+1)
Dim LandREx#(NumOfLands+1)
Dim LandREy#(NumOfLands+1)
Dim LandREz#(NumOfLands+1)
Dim LandEType(NumOfLands+1)
Dim LandMesh(NumOfLands+1)

; Load landscape data into array and generate 
For LoadLoop = 1 To NumOfLands

	LandName$(LoadLoop) = ReadLine(landfile)
	LandMeshFilename$(LoadLoop) = ReadLine(landfile)
	LandPEx#(LoadLoop) = Float(ReadLine(landfile))
	LandPEy#(LoadLoop) = Float(ReadLine(landfile))
	LandPEz#(LoadLoop) = Float(ReadLine(landfile))
	LandSEx#(LoadLoop) = Float(ReadLine(landfile))
	LandSEy#(LoadLoop) = Float(ReadLine(landfile))
	LandSEz#(LoadLoop) = Float(ReadLine(landfile))
	LandREx#(LoadLoop) = Float(ReadLine(landfile))
	LandREy#(LoadLoop) = Float(ReadLine(landfile))
	LandREz#(LoadLoop) = Float(ReadLine(landfile))
	LandEType(LoadLoop) = Int(ReadLine(landfile))

	LandMesh(LoadLoop) = LoadMesh(LandMeshFilename$(LoadLoop))
	
	PositionEntity LandMesh(LoadLoop), LandPEx#(LoadLoop), LandPEy#(LoadLoop), LandPEz#(LoadLoop)
	ScaleEntity LandMesh(LoadLoop), LandSEx#(LoadLoop), LandSEy#(LoadLoop), LandSEz#(LoadLoop)
	RotateEntity LandMesh(LoadLoop), LandREx#(LoadLoop), LandREy#(LoadLoop), LandREz#(LoadLoop)
	EntityType LandMesh(LoadLoop), LandEType(LoadLoop)

Next
CloseFile(landfile)
; End landscape model load sequence


; Set up collision matrices
; EntityType 1 = Camera (player)
; EntityType 2 = Solid landscape or character
Collisions 1, 2, 2, 3
Collisions 2, 1, 2, 3

; ********************************
; **** BEGINNING OF MAIN LOOP ****
; ********************************

While Not KeyDown(1)  
     TurnEntity CamPivot, 0, 0 - (MouseXSpeed()/2), 0 ; Left/Right rotation
     TurnEntity Camera, (MouseYSpeed()/2), 0, 0 ; Up/down rotation
     RotateEntity CamPivot, EntityPitch#( CamPivot ), EntityYaw#( CamPivot ), 0 ; Z roll correction
     MoveMouse GraphicsWidth()/2, GraphicsHeight()/2 ; Reset mouse pointer to center of screen
     RotateEntity Camera, EntityPitch#( Camera ), EntityYaw#( CamPivot ), 0 ; Z roll correction

     If MouseDown(3) = 1 ; Walk key toggle (middle mouse button)
          WalkTemp#=WalkSpeed#
	      If WalkTemp=1.5 Then WalkSpeed# = .3
	      If WalkTemp=.3 Then WalkSpeed# = 1.5
	      While MouseDown(3)
	      Wend
     EndIf

     If KeyDown(31) = 1 ; Walk key toggle (S key)
          WalkTemp#=WalkSpeed#
	      If WalkTemp=1.5 Then WalkSpeed# = .3
	      If WalkTemp=.3 Then WalkSpeed# = 1.5
	      While KeyDown(31)
	      Wend
     EndIf

     If MouseDown(1) = 1 ; Fly mode toggle (left mouse button)
		  FlyTemp=FlyMode
	      If FlyTemp=1 Then FlyMode=0
		  If FlyTemp=0 Then FlyMode=1
		  While MouseDown(1)
		  Wend
     EndIf

     ; Forward / reverse movement in flight or walk mode
     If FlyMode=0
          If MouseDown(2) Then MoveEntity CamPivot, 0, 0, WalkSpeed# ; Forward (right mouse button)
          If KeyDown(57) Then MoveEntity CamPivot, 0, 0, 0-WalkSpeed# ; Reverse (space bar)
          PositionEntity Camera, EntityX#( CamPivot ), EntityY#( CamPivot ), EntityZ#( CamPivot )
     Else
          If MouseDown(2) Then MoveEntity Camera, 0, 0, WalkSpeed#
          If KeyDown(57) Then MoveEntity Camera, 0, 0, 0-WalkSpeed#
          PositionEntity CamPivot, EntityX#( Camera ), EntityY#( Camera ), EntityZ#( Camera )
     EndIf


     ; Gravity check
     If FlyMode=0
          If EntityCollided( CamPivot, 2)
               ; Do nothing if player is in contact with terrain
               PlayerGravity# = 0.0
          Else
               PlayerGravity# = PlayerGravity# - Gravity#
          EndIf
     EndIf
     ; End of gravity check
     TranslateEntity CamPivot, 0, PlayerGravity#, 0 ; Move player according to current gravity force

	 If KeyDown(19) ; Reset to middle (R key)
		  If Flymode = 1 Then PositionEntity Camera, 1230, 16.3, 1240, True
		  If Flymode = 0 Then PositionEntity CamPivot, 1230, 16.3, 1240, True
		  While KeyDown (19)
		  Wend
     EndIf

    ; Update and render 3D graphics 
    UpdateWorld
	RenderWorld

	If KeyDown(32) ; Display coordinates upon D key
		Text 0,588,"X: " + EntityX#(Camera, True) + "  Z: " + EntityZ#(Camera, True) + " Y (Height): " + EntityY#(Camera, True)
	EndIf
	
	If KeyDown(18) ; Choose character with E key
		ChosenChar = 0
		NearestTargetHandle=EntityPick(Camera,5000)
		For TargetLoop = 1 To NumOfCharacters
			If NearestTargetHandle = CharMesh(TargetLoop)
			   ChosenChar = TargetLoop
			EndIf
		Next
	EndIf
	
	If Not ChosenChar = 0 ; Perform loop if a character is chosen
		If KeyDown(74)
			ModifyScale# = ModifyScale# - 0.01
				If ModifyScale# < 0.01
					ModifyScale# = 0.01
				EndIf
		EndIf
		If KeyDown(78)
			ModifyScale# = ModifyScale# + 0.01
		EndIf
		ScaleEntity CharMesh(ChosenChar), (CharSEx#(ChosenChar) * ModifyScale#), (CharSEy#(ChosenChar) * ModifyScale#), (CharSEz#(ChosenChar) * ModifyScale#)
		Text 0,560,"Name: " + CharName$(ChosenChar) + "  Scale Modify: " + Left$((Str(ModifyScale#)),4)
	Else
		ModifyScale# = 1.0
	EndIf	
	
	If KeyDown(25) = 1 ; Pause simulation upon P key
		ShowPointer
		Text 0, 588, "SIMULATION PAUSED (Press P to unpause)"
		Flip
		While KeyDown(25)
		Wend
		While Not KeyDown(25)
		Wend
		While KeyDown(25)
		Wend
		HidePointer
	EndIf
	
	; Display rendered screen from buffer
	Flip

Wend

; ********************************
; ******* END OF MAIN LOOP *******
; ********************************

; Program shutdown

EndGraphics

End

; -------------------------------------------------------------------------------
; Called functions
; -------------------------------------------------------------------------------

; Function to create box with illusion of sky
Function MakeSkyBox( file$ )

	m=CreateMesh()
	; Front face
	b=LoadBrush( file$+"_FR.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,-1,0,0:AddVertex s,+1,+1,-1,1,0
	AddVertex s,+1,-1,-1,1,1:AddVertex s,-1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	; Right face
	b=LoadBrush( file$+"_LF.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,-1,0,0:AddVertex s,+1,+1,+1,1,0
	AddVertex s,+1,-1,+1,1,1:AddVertex s,+1,-1,-1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	; Back face
	b=LoadBrush( file$+"_BK.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,+1,+1,+1,0,0:AddVertex s,-1,+1,+1,1,0
	AddVertex s,-1,-1,+1,1,1:AddVertex s,+1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	; Left face
	b=LoadBrush( file$+"_RT.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,0:AddVertex s,-1,+1,-1,1,0
	AddVertex s,-1,-1,-1,1,1:AddVertex s,-1,-1,+1,0,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b
	; Top face
	b=LoadBrush( file$+"_UP.bmp",49 )
	s=CreateSurface( m,b )
	AddVertex s,-1,+1,+1,0,1:AddVertex s,+1,+1,+1,0,0
	AddVertex s,+1,+1,-1,1,0:AddVertex s,-1,+1,-1,1,1
	AddTriangle s,0,1,2:AddTriangle s,0,2,3
	FreeBrush b

	ScaleMesh m,3000,3000,3000
	FlipMesh m
	EntityFX m,9
	EntityOrder m,10
	Return m
	
End Function